CREATE TABLE EVENT_OUT_USER
(
  ID                 NUMERIC(16,0)             NOT NULL,
  ERC_ID             NUMERIC(16,0)             NOT NULL,
  ERC_NAME           VARCHAR(64),
  OPERATION          NUMERIC(3,0)              NOT NULL,
  TRACE              VARCHAR(2000),
  STATUS             NUMERIC(1,0)              DEFAULT 0 NOT NULL,
  LAST_MOD_USER      VARCHAR(128),
  LAST_MOD_TIME      DATE,
  DATE_EVENT         DATE                      DEFAULT CURRENT_DATE,
  OBJ_CODE           VARCHAR(128),
  EXT_ATTR1          VARCHAR(128),
  EXT_ATTR2          VARCHAR(128),
  EXT_ATTR3          VARCHAR(128),
  EXT_ATTR4          VARCHAR(128),
  EXT_ATTR5          VARCHAR(128),
  EXT_ATTR6          VARCHAR(128),
  EXT_ATTR7          VARCHAR(128),
  EXT_ATTR8          VARCHAR(128),
  EXT_ATTR9          VARCHAR(128),
  EXT_ATTR10         VARCHAR(128)
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
;

ALTER TABLE EVENT_OUT_USER
  ADD CONSTRAINT EVENT_OUT_USER_PK
  PRIMARY KEY (ID);

CREATE INDEX EVENT_OUT_USER_ERC_ID_IDX ON EVENT_OUT_USER (ERC_ID);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE EVENT_OUT_USER' );

GRANT ALL ON EVENT_OUT_USER TO IGA;
GRANT ALL ON EVENT_OUT_USER TO IGACONN;

CREATE SEQUENCE EVENT_OUT_USER_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

GRANT USAGE ON SEQUENCE EVENT_OUT_USER_SEQ TO IGA;
GRANT USAGE ON SEQUENCE EVENT_OUT_USER_SEQ TO IGACONN;
