declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE EVENT_OUT_USER
  (
    ID                 NUMERIC(16,0)             NOT NULL,
    ERC_ID             NUMERIC(16,0)             NOT NULL,
    ERC_NAME           VARCHAR(64),
    OPERATION          NUMERIC(3,0)              NOT NULL,
    COD_OPERATION      VARCHAR(128)              NOT NULL,
    TRACE              VARCHAR(2000),
    STATUS             NUMERIC(1,0)              DEFAULT 0 NOT NULL,
    LAST_MOD_USER      VARCHAR(128),
    LAST_MOD_TIME      DATE,
    DATE_EVENT         DATE                      DEFAULT CURRENT_DATE,
    OBJ_CODE           VARCHAR(128),
    EXT_ATTR1          VARCHAR(128),
    EXT_ATTR2          VARCHAR(128),
    EXT_ATTR3          VARCHAR(128),
    EXT_ATTR4          VARCHAR(128),
    EXT_ATTR5          VARCHAR(128),
    EXT_ATTR6          VARCHAR(128),
    EXT_ATTR7          VARCHAR(128),
    EXT_ATTR8          VARCHAR(128),
    EXT_ATTR9          VARCHAR(128),
    EXT_ATTR10         VARCHAR(128)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE EVENT_OUT_USER
    ADD CONSTRAINT EVENT_OUT_USER_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- An index with a matching definition already exists

begin
  stat := '
  CREATE INDEX EVENT_OUT_USER_ERC_ID_IDX ON EVENT_OUT_USER (ERC_ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE EVENT_OUT_USER' );

GRANT ALL ON EVENT_OUT_USER TO IGA;
GRANT ALL ON EVENT_OUT_USER TO IGACONN;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE EVENT_OUT_USER_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE EVENT_OUT_USER_SEQ TO IGA;
GRANT USAGE ON SEQUENCE EVENT_OUT_USER_SEQ TO IGACONN;
