CREATE TABLE EVENT_OUT_USER
(
  ID                 NUMBER(16,0)             NOT NULL,
  ERC_ID             NUMBER(16,0)             NOT NULL,
  ERC_NAME           VARCHAR2(64),
  OPERATION          NUMBER(3,0)              NOT NULL,
  TRACE              VARCHAR2(2000),
  STATUS             NUMBER(1,0)              DEFAULT 0 NOT NULL,
  LAST_MOD_USER      VARCHAR2(128),
  LAST_MOD_TIME      DATE,
  DATE_EVENT         DATE                     DEFAULT SYSDATE,
  OBJ_CODE           VARCHAR2(128),
  EXT_ATTR1          VARCHAR2(128),
  EXT_ATTR2          VARCHAR2(128),
  EXT_ATTR3          VARCHAR2(128),
  EXT_ATTR4          VARCHAR2(128),
  EXT_ATTR5          VARCHAR2(128),
  EXT_ATTR6          VARCHAR2(128),
  EXT_ATTR7          VARCHAR2(128),
  EXT_ATTR8          VARCHAR2(128),
  EXT_ATTR9          VARCHAR2(128),
  EXT_ATTR10         VARCHAR2(128)
)
TABLESPACE &DATA_TABLESPACE
;

ALTER TABLE EVENT_OUT_USER
  ADD CONSTRAINT EVENT_OUT_USER_PK PRIMARY KEY (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

CREATE INDEX EVENT_OUT_USER_ERC_ID_IDX ON EVENT_OUT_USER (ERC_ID)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

GRANT ALL ON EVENT_OUT_USER TO IDEAS;
GRANT ALL ON EVENT_OUT_USER TO IDEAS_CONNECTOR;

CREATE SEQUENCE EVENT_OUT_USER_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER;

GRANT ALL ON EVENT_OUT_USER_SEQ TO IDEAS;
GRANT ALL ON EVENT_OUT_USER_SEQ TO IDEAS_CONNECTOR;
