declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE EVENT_OUT_USER
  (
    ID                 NUMBER(16,0)             NOT NULL,
    ERC_ID             NUMBER(16,0)             NOT NULL,
    ERC_NAME           VARCHAR2(64),
    OPERATION          NUMBER(3,0)              NOT NULL,
    COD_OPERATION      VARCHAR2(128)            NOT NULL,
    TRACE              VARCHAR2(2000),
    STATUS             NUMBER(1,0)              DEFAULT 0 NOT NULL,
    LAST_MOD_USER      VARCHAR2(128),
    LAST_MOD_TIME      DATE,
    DATE_EVENT         DATE                     DEFAULT SYSDATE,
    OBJ_CODE           VARCHAR2(128),
    EXT_ATTR1          VARCHAR2(128),
    EXT_ATTR2          VARCHAR2(128),
    EXT_ATTR3          VARCHAR2(128),
    EXT_ATTR4          VARCHAR2(128),
    EXT_ATTR5          VARCHAR2(128),
    EXT_ATTR6          VARCHAR2(128),
    EXT_ATTR7          VARCHAR2(128),
    EXT_ATTR8          VARCHAR2(128),
    EXT_ATTR9          VARCHAR2(128),
    EXT_ATTR10         VARCHAR2(128)
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE EVENT_OUT_USER
    ADD CONSTRAINT EVENT_OUT_USER_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE INDEX EVENT_OUT_USER_ERC_ID_IDX ON EVENT_OUT_USER (ERC_ID)
  NOLOGGING
  NOPARALLEL
  TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON EVENT_OUT_USER TO IDEAS;
GRANT ALL ON EVENT_OUT_USER TO IDEAS_CONNECTOR;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE EVENT_OUT_USER_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON EVENT_OUT_USER_SEQ TO IDEAS;
GRANT ALL ON EVENT_OUT_USER_SEQ TO IDEAS_CONNECTOR;
