CREATE OR REPLACE TRIGGER TRG_USER_EVENT_ERC_EVENT_OUT
  AFTER UPDATE OR DELETE ON USER_EVENT_ERC
  FOR EACH ROW
declare
  per_prof_status      number(16);
  feedback_status      number(16);
  counter              number(16);
  upd_person_profile   boolean := true;
begin
  if ( updating and ( :new.status is null OR ( :new.status = :old.status ) OR :new.event_out is null ) ) then
    return;
  end if;

  if ( deleting and ( :old.status is null OR :old.event_out is null ) ) then
    return;
  end if;

  if ( updating ) then
    update event_out set erc_status = :new.status, trace = :new.trace where id = :new.event_out;

    --se non esiste l'entry su person_profile, la tabella person_profile non si allinea, ma la feedback si
    select count(1) into counter from person_profile t where t.ext_id = :new.event_out;
    if ( counter = 0 ) then
      upd_person_profile := false;
    end if;

    if ( :new.status = 1 ) then
      if ( :new.operation = 1 ) then
        per_prof_status  := 2;
        --assegnazione permesso su target: OK
        if ( upd_person_profile = true ) then
          update person_profile set status = per_prof_status, verify_date = sysdate
          where ext_id = :new.event_out;
        end if;
      elsif ( :new.operation = 2 ) then
        --rimozione permesso su target: OK
        if ( upd_person_profile = true ) then
          delete from person_profile where ext_id = :new.event_out;
        end if;
      elsif ( :new.operation = 9 ) then
        delete from person_profile where account_code = :old.user_id and target = :old.target and status = 13; 
      end if;
    end if;

    if ( :new.status >= 2 ) then
      if ( :new.operation = 1 ) then
        --assegnazione permesso su target: KO
        per_prof_status  := 3;
      elsif ( :new.operation = 2 ) then
        --rimozione permesso su target: KO
        per_prof_status  := 13;
      end if;
      if ( upd_person_profile = true ) then
        update person_profile set status = per_prof_status, verify_date = sysdate
        where ext_id = :new.event_out;
      end if;
    end if;

    if ( :new.operation in ( 1, 2, 6, 7, 11 ) ) then
      if ( :new.status = 1 ) then
        feedback_status := 1;
      elsif ( :new.status >= 2 ) then
        feedback_status := 2;
      else
        feedback_status := -1;
      end if;

      if ( feedback_status <> -1 ) then
        if ( :new.operation in ( 1, 2  ) ) then
          select count(1) into counter from feedback
          where lower ( funct_application ) = lower ( :new.application ) and lower ( application ) = lower ( :new.target )
          and lower ( funct_type ) = lower ( :new.attr2 ) and lower ( funct ) = lower ( :new.attr3 )
          and lower ( cod_operation ) = lower ( :new.cod_operation ) and operation = :new.operation
          and user_erc = :new.user_erc;
        elsif ( :new.operation in ( 6, 7, 11  ) ) then
          select count(1) into counter from feedback
          where lower ( application ) = lower ( :new.target )
          and lower ( cod_operation ) = lower ( :new.cod_operation ) and operation = :new.operation
          and user_erc = :new.user_erc;
        end if;

        if ( counter = 1 ) then
          if ( :new.operation in ( 1, 2  ) ) then
            update feedback
            set status = feedback_status
            where lower ( funct_application ) = lower ( :new.application ) and lower ( application ) = lower ( :new.target )
            and lower ( funct_type ) = lower ( :new.attr2 ) and lower ( funct ) = lower ( :new.attr3 )
            and lower ( cod_operation ) = lower ( :new.cod_operation ) and operation = :new.operation
            and user_erc = :new.user_erc;
          elsif ( :new.operation in ( 6, 7, 11  ) ) then
            update feedback
            set status = feedback_status
            where lower ( application ) = lower ( :new.target )
            and lower ( cod_operation ) = lower ( :new.cod_operation ) and operation = :new.operation
            and user_erc = :new.user_erc;
          end if;
        end if;
      end if;
    end if;

  elsif ( deleting ) then
    update event_out set erc_status = :old.status, trace = :old.trace where id = :old.event_out;

    --se non esiste l'entry su person_profile, usciamo dal trigger, la tabella perxson_profile non si allinea
    select count(1) into counter from person_profile t where t.ext_id = :old.event_out;
    if ( counter = 0 ) then
      upd_person_profile := false;
    end if;

    if ( :old.status = 1 ) then
      if ( :old.operation = 1 ) then
        per_prof_status  := 2;
        --assegnazione permesso su target: OK
        if ( upd_person_profile = true ) then
          update person_profile set status = per_prof_status, verify_date = sysdate
          where ext_id = :old.event_out;
        end if;
      elsif ( :old.operation = 2 ) then
        --rimozione permesso su target: OK
        if ( upd_person_profile = true ) then
          delete from person_profile where ext_id = :old.event_out;
        end if;
      end if;
    end if;

    if ( :old.operation in ( 1, 2, 6, 7, 11  ) ) then
      if ( :old.status = 1 ) then
        feedback_status := 1;
      elsif ( :old.status >= 2 ) then
        feedback_status := 2;
      else
        feedback_status := -1;
      end if;

      if ( feedback_status <> -1 ) then
        if ( :old.operation in ( 1, 2  ) ) then
          select count(1) into counter from feedback
          where lower ( funct_application ) = lower ( :old.application ) and lower ( application ) = lower ( :old.target )
          and lower ( funct_type ) = lower ( :old.attr2 ) and lower ( funct ) = lower ( :old.attr3 )
          and lower ( cod_operation ) = lower ( :old.cod_operation ) and operation = :old.operation
          and user_erc = :old.user_erc;
        elsif ( :old.operation in ( 6, 7, 11  ) ) then
          select count(1) into counter from feedback
          where lower ( application ) = lower ( :old.target )
          and lower ( cod_operation ) = lower ( :old.cod_operation ) and operation = :old.operation
          and user_erc = :old.user_erc;
        end if;

        if ( counter = 1 ) then
          if ( :old.operation in ( 1, 2  ) ) then
            update feedback
            set status = feedback_status
            where lower ( funct_application ) = lower ( :old.application ) and lower ( application ) = lower ( :old.target )
            and lower ( funct_type ) = lower ( :old.attr2 ) and lower ( funct ) = lower ( :old.attr3 )
            and lower ( cod_operation ) = lower ( :old.cod_operation ) and operation = :old.operation
            and user_erc = :old.user_erc;
          elsif ( :old.operation in ( 6, 7, 11  ) ) then
            update feedback
            set status = feedback_status
            where lower ( application ) = lower ( :old.target )
            and lower ( cod_operation ) = lower ( :old.cod_operation ) and operation = :old.operation
            and user_erc = :old.user_erc;
          end if;
        end if;
      end if;
    end if;

  end if;

end TRG_USER_EVENT_ERC_EVENT_OUT;
/