set define off
declare
  im_id         number(16);
  im_name       varchar2(256) := 'AGC';

  fc_id         number(16);
  fc_name       varchar2(256) := 'system';
  
  fevt_id       number(16);
  fevt_name     varchar2(256) := 'OUT';
  
  f_id          number(16);
  f_name        varchar2(256) := 'BEFORE';
  
  fr_id         number(16);
  fr_name       varchar2(256) := 'Manual fulfillment - Create ARM Request for Operator';
  fr_desc       varchar2(512) := '[V1.0 - 2017-09-20]'; 
  
  fr_lob        clob := 'rule "Manual fulfillment - Create ARM Request for Operator"
'||'when 
'||'    event : EventOutBean(  ) 
'||'then 
'||'// 
'||'
'||'java.util.Properties properties = new java.util.Properties(); 
'||'
'||'// Overriding of the ARM flows 
'||'// By default this rule looks for the out of the box flows 
'||'//properties.setProperty("system.process.<operation>", "MyCustomFlow"); 
'||'
'||'// Custom request note for system events 
'||'// If null, default note is COD_OPERATION 
'||'String requestNote = null; 
'||'
'||'// Custom applicant UserID for system events 
'||'// If null default is "System" 
'||'// The user must exists 
'||'String systemUserCode = null; 
'||'
'||'// Create request 
'||'com.crossideas.ap.common.ruleengine.action.OperatorAction.createRequests4Operator(sql, logger, event, requestNote, systemUserCode, properties); 
'||'
'||'end
'||'
'||'
';

  counter       number(16);
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND' );
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND' );
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  if ( counter = 1 ) then
    select t.id into fevt_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW EVENT TYPE FOUND' );
  end if;
  
  select count(1) into counter from flow t
  where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name ); 
  if ( counter = 1 ) then
    select t.id into f_id from flow t
    where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW FOUND' );
  end if;

  select count(1) into counter from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );
  if ( counter = 0 ) then
    select flow_rule_seq.nextval into fr_id from dual;
    insert into flow_rule ( id, flow, name, description, rule_lob, ideas_module )
    values ( fr_id, f_id, fr_name, fr_desc, fr_lob, im_id );
  else
    select t.id into fr_id from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );
    update flow_rule set description = fr_desc where id = fr_id;
    update flow_rule set rule_lob = fr_lob where id = fr_id;
  end if;

end;
/
commit;
set define on
